#ifndef CLASS_DEFINE
struct log_info
{
  struct ol_object super;
  time_t recvd;
  struct log_handler *source;
  int pri;
  struct long_string *msg;
  struct long_string *date;
  struct long_string *program;
  struct long_string *host;
};
extern struct ol_class log_info_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_log_info_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct log_info *i = (struct log_info *) o;
  mark((struct ol_object *) i->source);
}

static void do_log_info_free(struct ol_object *o)
{
  struct log_info *i = (struct log_info *) o;
  long_string_free(i->msg);
  long_string_free(i->date);
  long_string_free(i->program);
  long_string_free(i->host);
}

struct ol_class log_info_class =
{ STATIC_HEADER,
  0, "log_info", sizeof(struct log_info),
  do_log_info_mark,
  do_log_info_free
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct log_handler
{
  struct ol_object super;
  void (*(handler))(struct log_handler *self, struct log_info *);
  int (*(init))(struct log_handler *self);
};
extern struct ol_class log_handler_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
struct ol_class log_handler_class =
{ STATIC_HEADER,
  0, "log_handler", sizeof(struct log_handler),
  NULL,
  NULL
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct log_handler_pipe
{
  struct log_handler super;
  struct log_handler *next;
};
extern struct ol_class log_handler_pipe_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_log_handler_pipe_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct log_handler_pipe *i = (struct log_handler_pipe *) o;
  mark((struct ol_object *) i->next);
}

struct ol_class log_handler_pipe_class =
{ STATIC_HEADER,
  &log_handler_class, "log_handler_pipe", sizeof(struct log_handler_pipe),
  do_log_handler_pipe_mark,
  NULL
};
#endif /* !CLASS_DECLARE */

