/***************************************************************************
 *
 * Portions copyright (C) 1998-1999 Niels Mller
 * Copyright (c) 1999 BalaBit Computing
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Inspired by nsyslog, originally written by Darren Reed.
 *
 * $Id: lstring.c,v 1.1.1.1 1999/02/08 14:47:33 bazsi Exp $
 *
 ***************************************************************************/

#include "objects.h"
#include "lstring.h"

struct long_string *long_string_alloc(UINT32 length)
{
  struct long_string *s
    = xalloc(sizeof(struct long_string) - 1 + length);
#ifdef DEBUG_ALLOC
  s->header.magic = -1717;
#endif
  s->length = length;
  s->sequence_number = 0;
  return s;
}

void long_string_free(struct long_string *s)
{
  if (!s)
    return;

  debug("long_string_free: freeing %p,\n", (void *) s);
  
#ifdef DEBUG_ALLOC
  if (s->header.magic != -1717)
    fatal("long_string_free: Not string!\n");
#endif
  ol_free(s);
}
