/***************************************************************************
 *
 * Portions copyright (C) 1998-1999 Niels Mller
 * Copyright (c) 1999 BalaBit Computing
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Inspired by nsyslog, originally written by Darren Reed.
 *
 * $Id: lstring.h,v 1.1.1.1 1999/02/08 14:47:33 bazsi Exp $
 *
 ***************************************************************************/

#ifndef __LSTRING_H_INCLUDED
#define __LSTRING_H_INCLUDED

#ifdef DEBUG_ALLOC

struct long_string_header
{
  int magic; /* For a sentinel value */
};

#else   /* !DEBUG_ALLOC */

struct long_string_header {};

#endif  /* !DEBUG_ALLOC */

struct long_string
{
  struct long_string_header header;

  UINT32 sequence_number;
  /* NOTE: The allocated size may be larger than the string length. */
  UINT32 length;
  UINT8 data[1];
};

struct long_string *long_string_alloc(UINT32 length);
void long_string_free(struct long_string *s);

#endif
