/***************************************************************************
 *
 * Copyright (c) 1999 BalaBit Computing
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Inspired by nsyslog, originally written by Darren Reed.
 *
 * $Id: syslog-ng.h,v 1.5 1999/03/08 19:25:37 bazsi Exp $
 *
 ***************************************************************************/

#ifndef __SYSLOG_NG_H
#define __SYSLOG_NG_H

#include "config.h"

#include "objects.h"

/* failure indication */
#define ST_OK		0
#define ST_FAIL		1

/* action to take */
#define ST_GOON		0
#define ST_CLOSE	2	/* close this source or destination */
#define ST_QUIT		4	/* quit program, may occur during config init */

#define ST_FAILUREP(x) ((x) & ST_FAIL)
#define ST_CLOSEDP(x) ((x) & (ST_FAIL | ST_CLOSE))

#define MAX_LOG_LINE		1024
#define MAX_HOSTNAME		128
#define MAX_TOKEN		128

#define LOG_FIFO_SIZE		100

#endif
